import pygame
from pygame.locals import *
from lib.SpriteManager import SpriteManager

screen_width = 1024
screen_height = 600

class Test2(SpriteManager):

    def __init__(self):
        SpriteManager.__init__(self)
        self.loadSprites()
        self.defaultSurface(self.move_left)
        self.initialPosition(400,100)
        self.velocity = 10
        self.movement = 1
        self.angle = 1
        

    def loadSprites(self):
        self.move_left = self.getAnimation('resources/test2/andar-izquierda', 'left')
        self.move_right = self.getAnimation('resources/test2/andar-izquierda', 'right', True)
        self.move_up = self.getAnimation('resources/test2/andar-arriba', 'up')
        self.move_down = self.getAnimation('resources/test2/andar-abajo', 'down')
        self.agacharse = self.getAnimation('resources/test/agacharse', 'agacharse')
    
    def ia(self):
        
        rect = self.rect

        if (rect.left + rect.width) >= screen_width:
            self.movement = -1
        elif rect.left <= 0:
           self.movement = 1

        self.move(self.movement * self.velocity, 0)
 

        if self.movement == 1:
            
            self.surface = self.animate(self.move_right)

        else:
            
            self.surface = self.animate(self.move_left)



    def moveLeft(self):
        self.move(-self.velocity,0)
        self.surface = self.animate(self.move_left)

    def moveRight(self):
        self.move(self.velocity,0)
        self.surface = self.animate(self.move_right)

    def moveUp(self):
        self.move(0,-self.velocity)
        self.surface = self.animate(self.move_up)

    def moveDown(self):
        self.move(0,self.velocity)
        self.surface = self.animate(self.move_down)

    def colisionado(self):
        self.surface = self.animate(self.agacharse)
        self.hide()

    def controls(self, controls):
        """Define tus propios controles"""

        if controls.keyPressed(K_j) and not controls.keyPressed(K_i):
            self.moveLeft()
        if controls.keyPressed(K_l) and not controls.keyPressed(K_k):
            self.moveRight()
        if controls.keyPressed(K_i) and not controls.keyPressed(K_l):
            self.moveUp()
        if controls.keyPressed(K_k) and not controls.keyPressed(K_j):
            self.moveDown()

        if controls.keyPressed(K_j) and controls.keyPressed(K_i):
            self.moveLeft()
            self.moveUp()
        if controls.keyPressed(K_l) and controls.keyPressed(K_k):
            self.moveRight()
            self.moveDown()
        if controls.keyPressed(K_i) and controls.keyPressed(K_l):
            self.moveUp()
            self.moveRight()
        if controls.keyPressed(K_k) and controls.keyPressed(K_j):
            self.moveDown()
            self.moveLeft()

        if controls.keyPressed(K_SPACE):
            self.show()


