from lib.Engine import Engine
import pygame, sys, os

from game.intro.MainMenu import MainMenu
from game.selectPlayer.SelectPlayer import SelectPlayer
from game.selectMode.SelectMode import SelectMode
from game.freeMode.FreeMode import FreeMode
import constants

from game.configMenu.ConfigMenu import ConfigMenu


class Arcadia(Engine):

    def __init__(self):
        self.screen_width = 1024
        self.screen_height = 600
        self.tileSize = 48
        self.ticks = 30
        self.title_game = "Arcadia"
        self.flags = 0
        

        #we call parent constructor
        Engine.__init__(self)
        self.games.append(MainMenu(self))
        self.games.append(SelectPlayer(self))
        self.games.append(SelectMode(self))
        self.games.append(FreeMode(self))
        self.games.append(ConfigMenu(self))

        #iniciamos MainMenu por defecto
        self.game = self.games[0]
        
    def paint(self):
        self.game.paint()
        self.renderManager.paintGUI(self.gui.getGUI())

    def logic(self):
        if not self.pause:
            self.game.logic()

    def controls(self):
        self.game.controls()
        

if __name__ == "__main__":

    #start game
    game = Arcadia()
    game.mainLoop()



