import pygame
import os, sys
from lib.ConfigManager import ConfigHandler
from Game import Game
from game.intro.Fondo import Fondo
from lib.Shadows import *
from lib.SimpleSurface import SimpleSurface


class ConfigMenu(Game):

    def __init__(self, core):

        Game.__init__(self,core)
        self.core = core
        self.core.font.selectCustomFont("kimbalt_", 30)


        #INFORMATION
        self.titulo = self.core.font.renderText("Configuracion:", self.core.screen_width * 0.01, self.core.screen_height * 0.05, (0,153,255))
        sombra = add_shadow(self.titulo.getSurface(), (2,2))
        self.titulo.setSurface(sombra)

        self.fondo = Fondo()
        self.barra_superior = SimpleSurface("game"+os.path.sep+"configMenu"+os.path.sep+"images"+os.path.sep+"barra_superior"+os.path.sep+"barra_superior.png")
        


        #FONTS
        self.core.font.selectCustomFont("kimbalt_", 48)

        color=(255,255,255)
        self.video = self.core.font.renderText("Video", self.core.screen_width * 0.2, self.core.screen_height * 0.3, color)
        sombra = add_shadow(self.video.getSurface(), (2,2))
        self.video.setSurface(sombra)

        self.selectedVideo = self.core.font.renderText("Video", self.core.screen_width * 0.2, self.core.screen_height * 0.3, (255,0,0))
        sombra = add_shadow(self.selectedVideo.getSurface(), (2,2))
        self.selectedVideo.setSurface(sombra)


        self.sound = self.core.font.renderText("Sonido", self.core.screen_width * 0.2, self.core.screen_height * 0.4, color)
        sombra = add_shadow(self.sound.getSurface(), (2,2))
        self.sound.setSurface(sombra)

        self.selectedSound = self.core.font.renderText("Sonido", self.core.screen_width * 0.2, self.core.screen_height * 0.4, (255,0,0))
        sombra = add_shadow(self.selectedSound.getSurface(), (2,2))
        self.selectedSound.setSurface(sombra)



        self.control = self.core.font.renderText("Controles", self.core.screen_width * 0.2, self.core.screen_height * 0.5, color)
        sombra = add_shadow(self.control.getSurface(), (2,2))
        self.control.setSurface(sombra)

        self.selectedControl = self.core.font.renderText("Controles", self.core.screen_width * 0.2, self.core.screen_height * 0.5, (255,0,0))
        sombra = add_shadow(self.selectedControl.getSurface(), (2,2))
        self.selectedControl.setSurface(sombra)



        self.selecc = self.core.font.renderText("Seleccionar Configuracion", self.core.screen_width * 0.2, self.core.screen_height * 0.7, color)
        sombra = add_shadow(self.selecc.getSurface(), (2,2))
        self.selecc.setSurface(sombra)

        self.seleccS = self.core.font.renderText("Seleccionar Configuracion", self.core.screen_width * 0.2, self.core.screen_height * 0.7, (255,0,0))
        sombra = add_shadow(self.seleccS.getSurface(), (2,2))
        self.seleccS.setSurface(sombra)


        #MENU 
        self.selected=0
        self.options=3
        self.numPlayer=1
        self.mode=0 #0 -> Menu: Video, Sound, Controls
                    #10 -> Video
                    #11 -> Sonido
                    #12 -> Control
                    #13 -> Modificar Config

        
    def paint(self):
        self.paintItem(self.fondo)
        self.paintItem(self.barra_superior)
        self.paintItem(self.titulo)


        #MENU: Video-Sound-Controls-Select Config
        if self.mode==0:
            self.paintMainMenu()

        elif self.mode==10:
            #self.paintVideoMenu()
            
            if self.core.configManager.actualConfig.videoFullScreen:
                fS="Si"
            else:
                fS="No"
            self.paintMenu(elements=["Pantalla Completa","Resolucion"],values=[fS,str(self.core.configManager.actualConfig.videoResolutionX)+" x "+str(self.core.configManager.actualConfig.videoResolutionY)])

        elif self.mode==11:
            #self.paintSoundMenu()
            self.paintMenu(elements=["Volumen general","Volumen de sonidos","Volumen de musica"],values=[str(self.core.configManager.actualConfig.volumeGeneral),str(self.core.configManager.actualConfig.volumeSound),str(self.core.configManager.actualConfig.volumeMusic)])
            
        elif self.mode==12:

            #self.paintControlMenu()      
            self.paintMenu(elements=["  Jugador:","Arriba","Abajo","Izquierda","Derecha","Boton 1","Boton 2","Boton 3","Boton 4"],values=[str(self.numPlayer+1)]+self.core.configManager.actualConfig.controls[self.numPlayer].getButtonList())


        elif self.mode==13:
            self.pintarListaConfigs()
        else:
            pass



    def controls(self):


        #CONTROLES ABSOLUTOS
        if self.core.controlManager.controlEvents.count(("KEYBUTTON", pygame.K_f)) > 0:
            self.core.toggleFullScreen()

        
        #CONTROLES MOVIMIENTO
        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_UP)) > 0:
            try:
                self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_UP)))
            except ValueError:
                pass 
            if self.options<>0:
                self.selected=(self.selected-1)%self.options

    
        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_DOWN)) > 0:
            try:
                self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_DOWN)))
            except ValueError:
                pass
            if self.options<>0:
                self.selected=(self.selected+1)%self.options

        #CONTROLES PARA CAMBIOS

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_LEFT)) > 0:


            if self.mode==10:
                pass
            elif self.mode==11:
                pass
            elif self.mode==12:
                self.numPlayer=(self.numPlayer-1)%4
            elif self.mode==13:
                pass
            else:
                pass


            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_LEFT)))


        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RIGHT)) > 0:

            if self.mode==10:
                pass
            elif self.mode==11:
                pass
            elif self.mode==12:
                self.numPlayer=(self.numPlayer+1)%4
            elif self.mode==13:
                pass
            else:
                pass


            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RIGHT)))


        #CONTROLES CONTEXTUALES ---- RETURN
        
        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 0 and self.mode==0:
            self.mode=10
            self.options=0
            self.selected=0
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 1 and self.mode==0:
            self.mode=11
            self.options=0
            self.selected=0
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 2 and self.mode==0:
            self.mode=12
            self.options=0
            self.selected=0
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 3 and self.mode==0:
            self.mode=13
            if len(self.core.configManager.configs)>0:
                self.options=len(self.core.configManager.configs)

            else:
                self.options=0
            self.selected=0
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))


        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.mode==13:

            self.core.configManager.setActualConfigByPos(self.selected)

            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

        #CONTROLES CONTEXTUALES ---- ESCAPE

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_ESCAPE)) > 0:
            if self.mode==0:

                if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_LEFT)) > 0:
                    self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_LEFT)))
                if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RIGHT)) > 0:
                    self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RIGHT)))

                self.core.game = self.core.games[0]
        
            elif self.mode==10:
                self.mode=0
                self.options=4
                self.selected=0
            elif self.mode==11:
                self.mode=0
                self.options=4
                self.selected=1
            elif self.mode==12:
                self.mode=0
                self.options=4
                self.selected=2
            elif self.mode==13:
                self.mode=0
                self.options=4
                self.selected=3

            else:
                pass

            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_ESCAPE)))

    #ASSISTANCE


    def pintarListaConfigs(self):

        paintConfigs=[]

        pos=0.25
        i=0
        color=(0,0,0)

        lista=[]
        for e in self.core.configManager.configs:
            lista.append(e.name)

        self.core.font.selectCustomFont("kimbalt_", 30)

        for nom in lista:
            pos=pos+0.05
    
            if nom==self.core.configManager.actualConfig.name and i==self.selected:
                color=(100,100,255)           
            elif nom==self.core.configManager.actualConfig.name:
                color=(0,0,155)
            elif i==self.selected:
                color=(155,155,155)
            else:
                color=(0,0,0)
            paintConfigs.append(self.core.font.renderText(nom, self.core.screen_width * 0.20, self.core.screen_height * pos, color))
            i=i+1
        for e in paintConfigs:
            self.paintItem(e)


    def paintMainMenu(self):

            self.options=4
            if self.selected==0:
                self.paintItem(self.selectedVideo)
            else:
                self.paintItem(self.video)

            if self.selected==1:
                self.paintItem(self.selectedSound)
            else:
                self.paintItem(self.sound)

            if self.selected==2:
                self.paintItem(self.selectedControl)
            else:
                self.paintItem(self.control)

            if self.selected==3:
                self.paintItem(self.seleccS)
            else:
                self.paintItem(self.selecc)


    def paintMenu(self, elements=[], values=[], limitX=(0.2,0.6), limitY=(0.3,0.8)):

        self.core.font.selectCustomFont("kimbalt_", 30)

        els=len(elements)
        paintList=[]
        if els<>len(values) and els<=10:
            return 0
        else:
            i=0
            coordX=limitX[0]
            coordY=limitY[0]
            while ((i>=0) and (i<els)):
                
                coordY=limitY[0]+(limitY[1]-limitY[0])/els*i

                self.text = self.core.font.renderText(elements[i], self.core.screen_width * coordX, self.core.screen_height * coordY, (0,150,255))
                sombra = add_shadow(self.text.getSurface(), (2,2))
                self.text.setSurface(sombra)

                paintList.append(self.text)

                self.textValue = self.core.font.renderText(values[i], self.core.screen_width * ((coordX+0.4)%1.0), self.core.screen_height * coordY, (255,255,255))
                sombra = add_shadow(self.textValue.getSurface(), (2,2))
                self.textValue.setSurface(sombra)

                paintList.append(self.textValue)
                i=i+1

            for e in paintList:
                self.paintItem(e)




