import pygame
from pygame.locals import *
from FontManager import FontManager
from SpriteManager import SpriteManager
import FileManager

class GUIManager(object):
    """Clase para gestionar la GUI del juego ofreciendo determinados elementos hechos para interactuar con el usuario"""
    def __init__(self):
        self.GUI = {} #diccionario donde se guardan todos los objetos de la GUI para poder interactuar con ellos
        

    def getGUI(self):
        return self.GUI

    def dialogBox(self, name, text, size, left, top, width, height):
        
        if 'dialogbox-'+name not in self.GUI:

            font = FontManager(size)
            text = font.renderText(text, size, size)


            #cargamos todos los componentes del boton
            left_up = pygame.image.load(FileManager.locationFixer("resources/GUI/button/left-up.png")).convert_alpha()
            up = pygame.image.load(FileManager.locationFixer("resources/GUI/button/up.png")).convert_alpha()
            right_up = pygame.image.load(FileManager.locationFixer("resources/GUI/button/right-up.png")).convert_alpha()
            left_middle = pygame.image.load(FileManager.locationFixer("resources/GUI/button/left-middle.png")).convert_alpha()
            middle = pygame.image.load(FileManager.locationFixer("resources/GUI/button/middle.png")).convert_alpha()
            right_middle = pygame.image.load(FileManager.locationFixer("resources/GUI/button/right-middle.png")).convert_alpha()
            left_down = pygame.image.load(FileManager.locationFixer("resources/GUI/button/left-down.png")).convert_alpha()
            down = pygame.image.load(FileManager.locationFixer("resources/GUI/button/down.png")).convert_alpha()
            right_down = pygame.image.load(FileManager.locationFixer("resources/GUI/button/right-down.png")).convert_alpha()

            #reescalamos los items susceptibles
            up = pygame.transform.scale(up, (width,up.get_rect().height))
            left_middle = pygame.transform.scale(left_middle, (left_middle.get_rect().width, height))
            middle = pygame.transform.scale(middle, (width,height))
            right_middle = pygame.transform.scale(right_middle, (right_middle.get_rect().width, height))
            down = pygame.transform.scale(down, (width,down.get_rect().height))

            #configuramos coordenadas de las imagenes dependiendo de left-up
            left_up_rect = left_up.get_rect()
            up_rect = up.get_rect()
            right_up_rect = right_up.get_rect()
            left_middle_rect = left_middle.get_rect()
            middle_rect = middle.get_rect()
            right_middle_rect = right_middle.get_rect()
            left_down_rect = left_down.get_rect()
            down_rect = down.get_rect()
            right_down_rect = right_down.get_rect()

            left_up_rect.left = 0
            left_up_rect.top = 0
            up_rect.left = left_up_rect.left + left_up_rect.width
            up_rect.top = left_up_rect.top
            right_up_rect.left = up_rect.left + up_rect.width
            right_up_rect.top = left_up_rect.top

            left_middle_rect.left = left_up_rect.left
            left_middle_rect.top = left_up_rect.top + left_up_rect.height
            middle_rect.left = left_middle_rect.left + left_middle_rect.width
            middle_rect.top = left_up_rect.top + left_up_rect.height

            right_middle_rect.left = middle_rect.left + middle_rect.width
            right_middle_rect.top = right_up_rect.top + right_up_rect.height

            left_down_rect.left = left_up_rect.left
            left_down_rect.top = left_middle_rect.top + left_middle_rect.height
            down_rect.left = left_down_rect.left + left_down_rect.width
            down_rect.top = middle_rect.top + middle_rect.height
            right_down_rect.left = down_rect.left + down_rect.width
            right_down_rect.top = right_middle_rect.top + right_middle_rect.height

            #bliteamos todas las partes en una
            """self.GUI.append([left_up, left_up_rect])
            self.GUI.append([up, up_rect])
            self.GUI.append([right_up, right_up_rect])
            self.GUI.append([left_middle, left_middle_rect])
            self.GUI.append([middle, middle_rect])
            self.GUI.append([right_middle, right_middle_rect])
            self.GUI.append([left_down, left_down_rect])
            self.GUI.append([down, down_rect])
            self.GUI.append([right_down, right_down_rect])

            self.GUI.append([text.getSurface(), text.max_rect()])"""
            surface = pygame.Surface((width + left_up_rect.width + right_up_rect.width, height + left_up_rect.height + left_down_rect.height), SRCALPHA)
            #surface = pygame.Surface((width+2*left, height+2*top))
            surface.blit(left_up, left_up_rect)
            surface.blit(up, up_rect)
            surface.blit(right_up, right_up_rect)
            surface.blit(left_middle, left_middle_rect)
            surface.blit(middle, middle_rect)
            surface.blit(right_middle, right_middle_rect)
            surface.blit(left_down, left_down_rect)
            surface.blit(down, down_rect)
            surface.blit(right_down, right_down_rect)
            surface.blit(text.getSurface(), text.max_rect())

            surface_rect = surface.get_rect()
            surface_rect.left = left
            surface_rect.top = top
            self.GUI["dialogbox-"+name] = [surface, surface_rect]


    def genericBox(self, name, left, top, width, height, subsurface = None):
        
        if 'genericbox-'+name not in self.GUI:


            #cargamos todos los componentes del boton
            left_up = pygame.image.load(FileManager.locationFixer("resources/GUI/button/left-up.png")).convert_alpha()
            up = pygame.image.load(FileManager.locationFixer("resources/GUI/button/up.png")).convert_alpha()
            right_up = pygame.image.load(FileManager.locationFixer("resources/GUI/button/right-up.png")).convert_alpha()
            left_middle = pygame.image.load(FileManager.locationFixer("resources/GUI/button/left-middle.png")).convert_alpha()
            middle = pygame.image.load(FileManager.locationFixer("resources/GUI/button/middle.png")).convert_alpha()
            right_middle = pygame.image.load(FileManager.locationFixer("resources/GUI/button/right-middle.png")).convert_alpha()
            left_down = pygame.image.load(FileManager.locationFixer("resources/GUI/button/left-down.png")).convert_alpha()
            down = pygame.image.load(FileManager.locationFixer("resources/GUI/button/down.png")).convert_alpha()
            right_down = pygame.image.load(FileManager.locationFixer("resources/GUI/button/right-down.png")).convert_alpha()

            #reescalamos los items susceptibles
            up = pygame.transform.scale(up, (width,up.get_rect().height))
            left_middle = pygame.transform.scale(left_middle, (left_middle.get_rect().width, height))
            middle = pygame.transform.scale(middle, (width,height))
            right_middle = pygame.transform.scale(right_middle, (right_middle.get_rect().width, height))
            down = pygame.transform.scale(down, (width,down.get_rect().height))

            #configuramos coordenadas de las imagenes dependiendo de left-up
            left_up_rect = left_up.get_rect()
            up_rect = up.get_rect()
            right_up_rect = right_up.get_rect()
            left_middle_rect = left_middle.get_rect()
            middle_rect = middle.get_rect()
            right_middle_rect = right_middle.get_rect()
            left_down_rect = left_down.get_rect()
            down_rect = down.get_rect()
            right_down_rect = right_down.get_rect()

            left_up_rect.left = 0
            left_up_rect.top = 0
            up_rect.left = left_up_rect.left + left_up_rect.width
            up_rect.top = left_up_rect.top
            right_up_rect.left = up_rect.left + up_rect.width
            right_up_rect.top = left_up_rect.top

            left_middle_rect.left = left_up_rect.left
            left_middle_rect.top = left_up_rect.top + left_up_rect.height
            middle_rect.left = left_middle_rect.left + left_middle_rect.width
            middle_rect.top = left_up_rect.top + left_up_rect.height

            right_middle_rect.left = middle_rect.left + middle_rect.width
            right_middle_rect.top = right_up_rect.top + right_up_rect.height

            left_down_rect.left = left_up_rect.left
            left_down_rect.top = left_middle_rect.top + left_middle_rect.height
            down_rect.left = left_down_rect.left + left_down_rect.width
            down_rect.top = middle_rect.top + middle_rect.height
            right_down_rect.left = down_rect.left + down_rect.width
            right_down_rect.top = right_middle_rect.top + right_middle_rect.height

            #bliteamos todas las partes en una
            """self.GUI.append([left_up, left_up_rect])
            self.GUI.append([up, up_rect])
            self.GUI.append([right_up, right_up_rect])
            self.GUI.append([left_middle, left_middle_rect])
            self.GUI.append([middle, middle_rect])
            self.GUI.append([right_middle, right_middle_rect])
            self.GUI.append([left_down, left_down_rect])
            self.GUI.append([down, down_rect])
            self.GUI.append([right_down, right_down_rect])

            self.GUI.append([text.getSurface(), text.max_rect()])"""
            surface = pygame.Surface((width + left_up_rect.width + right_up_rect.width, height + left_up_rect.height + left_down_rect.height), SRCALPHA)
            surface.blit(left_up, left_up_rect)
            surface.blit(up, up_rect)
            surface.blit(right_up, right_up_rect)
            surface.blit(left_middle, left_middle_rect)
            surface.blit(middle, middle_rect)
            surface.blit(right_middle, right_middle_rect)
            surface.blit(left_down, left_down_rect)
            surface.blit(down, down_rect)
            surface.blit(right_down, right_down_rect)
                
            surface_rect = surface.get_rect()
            surface_rect.left = left
            surface_rect.top = top
            self.GUI["genericbox-"+name] = [surface, surface_rect]

    def hasElement(self, element):
        if element not in self.GUI:
            return False
        else:
            return True

    def remove(self, element):
        del self.GUI[element]
