class GroupManager(object):
    """clase para manejar grupos de sprites"""
    def __init__(self):
        self.group = []

    def get(self):
        return self.group

    def add(self, sprite):
        self.group.append(sprite)

    def remove(self, sprite):
        self.group.remove(sprite)

    def copy (self):
        newgroup = []

        for sprite in self.group:
            newgroup.append(sprite)

        return newgroup

    def empty(self):
        self.group = []

    def contains(self, sprite):
        
        if self.group.count(sprite) > 0:
            return True
        else:
            return False

    def hide(self):
        for sprite in self.group:
            sprite.hide()

    def show(self):
        for sprite in self.group:
            sprite.show()

    def move(self,x ,y):
        for sprite in self.group:
            sprite.move(x,y)

    def subgroup(self, offset, size):
        """devuelve una sublista [offset : offset+size]"""

        if offset + size > len(self.group):

            return self.group[offset:]
        else:
            return self.group[offset : (offset+size)]
        


