import pygame

class RenderManager(object):
    """Clase encargada de renderizar los sprites proporcionados por la logica del juego"""

    def __init__(self, core):
        """Inicializamos la clase con una copia del objeto del motor para acceder a configuraciones y propiedades"""
        self.core = core

    def updateFrame(self):
        """Metodo para renderizar las imagenes del juego. Se pasa una lista con objetos tipo Rect que definen las zonas que es necesario repintar, para no pintar toda la superficie en cada iteraccion con el consiguiente ahorro de recursos"""
        pygame.display.update(self.core.updatedSprites)
        self.core.updatedSprites = []
        #pygame.display.flip()

    def paintItem(self, item):
        """Metodo que pinta el item en pantalla"""

        self.core.screen.blit(item.getSurface(), item.rect)
        self.core.updatedSprites.append(item.max_rect())

    def paintGUI(self, gui):
        """Metodo que pinta los elementos de la GUI en pantalla"""
        for name, value in gui.iteritems():
            self.core.screen.blit(value[0], value[1])
            self.core.updatedSprites = value[1]


